#library "dinamicDoom"
#include "zcommon.acs"


#include "defs.acs"
#include "funcs.acs"
#include "dinamicMonsters.acs"
#include "dinamicProps.acs"
#include "itemsTracker.acs"
#include "hellmode.acs"
#include "fakeNightmare.acs"
#include "invasion.acs"
#include "monsterTracker.acs"
#include "dinamicTeleport.acs"
#include "paranoiaAddon.acs"
#include "betrugerAddon.acs"
#include "dinamicProjectiles.acs"
#include "smartMonsters.acs"
#include "dinamicActivation.acs"
//#include "test.acs" //para testear cosas, mas que nada matematicas

int firstEntered = 0;

script 855 OPEN
{
	dinamicShoots = false;
	int i, j;
	int rand = GetCVar("cv_gmtime") % 256;
    for (i = 0; i < rand; i++) Random(0,255);

	maxMonsterTid = minTID + MAX_MONSTERS_MAP;

	//ACS_ExecuteAlways(TESTMATH, 0);
	delay(10); //Por si las moscas le damos un respiro al programa de 1 segundo
	for (i=0; i < MAXPLAYERS; i++)
	{
		Palive[i] = FALSE;
		PactPos[i][0] = -1;
		PactPos[i][1] = -1;
		PactPos[i][2] = -1;
		SpawnPoints[i][0] = -1;
		SpawnPoints[i][1] = -1;
		SpawnPoints[i][2] = -1;
		PlayerAngle[i] = 0;
		
		cActOldPos[i] = 0;
		cRecentPos[i] = 0;
		for (j=0; j < MAXOLDPOS; j++)
		{
			PactOldPos[i][j][0] = -1;
			PactOldPos[i][j][1] = -1;
			PactOldPos[i][j][2] = -1;
		}
		for (j=0; j < MAXOLDPOS; j++)
		{
			PrecentPos[i][j][0] = -1;
			PrecentPos[i][j][1] = -1;
			PrecentPos[i][j][2] = -1;
		}
		
		for (j=0; j < MAXSPAWNPOINTS; j++)
		{
			MSpawnPos[i][j][0] = -1;
			MSpawnPos[i][j][1] = -1;
			MSpawnPos[i][j][2] = -1;
		}
	}
	delay(15); //Otro respiro mas
	ACS_ExecuteAlways(SERVER_RANDOM_START, 0);

	if (random(0, 100) <= 50)
		ACS_ExecuteAlways(SERVER_PROPS_START, 0);
	
	while (PlayerCount() <= 0)
		delay(20);

	delay(20);
	started = 1;
	if (random(0, 100) >= 50)
		ACS_ExecuteAlways(FNIGHTMARE_SCRIPT, 0);
	else
		fakeNightmare = false;

	delay(1);
    for (i = 0; i < rand; i++) Random(0,255);//Desbugear random
	
	if (random(0, 100) <= 50)
		ACS_ExecuteAlways(SERVER_HELLMODE_START, 0);

	delay(1);
    for (i = 0; i < rand; i++) Random(0,255);//Desbugear random		

	if (random(0, 100) >= 50)
		ACS_ExecuteAlways(SERVER_INVASION_START, 0);

	delay(1);
    for (i = 0; i < rand; i++) Random(0,255);//Desbugear random		

	if (random(0, 100) <= 50)	
		ACS_ExecuteAlways(SERVER_MTRACKER_START, 0);
		
	delay(1);
	for (i = 0; i < rand; i++) Random(0,255);//Desbugear random		
	if (random(0, 100) >= 50)
		ACS_ExecuteAlways(SERVER_TELEPORT_MTHING, 0);
	
	delay(1);
    for (i = 0; i < rand; i++) Random(0,255);//Desbugear random		

	if (random(0, 100) <= 50)
		ACS_ExecuteAlways(SERVER_PARANOIA_START, 0);
		
	delay(1);
    for (i = 0; i < rand; i++) Random(0,255);//Desbugear random		
	if (random(0, 100) >= 50)
		ACS_ExecuteAlways(SERVER_BETRUGER_START, 0);
		
	delay(1);
    for (i = 0; i < rand; i++) Random(0,255);//Desbugear random	
	if (random(0, 100) <= 50)
		 dinamicShoots = true;

	delay(1);
    for (i = 0; i < rand; i++) Random(0,255);//Desbugear random		
	if (random(0, 100) >= 50)
		ACS_ExecuteAlways(SERVER_SMART_START, 0);
		
	ACS_ExecuteAlways(SERVER_ACTV_START, 0);
}

script 666 ENTER
{
	do
	{
		delay(5);
	}while (!started);
	
	//Se ejecuta el script comenzada la ronda
	Thing_ChangeTID(0, MINPLAYERTID + PlayerNumber());
	int acTid = MINPLAYERTID + PlayerNumber();
	
	Palive[PlayerNumber()] = TRUE;
	SpawnPoints[PlayerNumber()][0] = GetActorX(0);
	SpawnPoints[PlayerNumber()][1] = GetActorY(0);
	SpawnPoints[PlayerNumber()][2] = GetActorZ(0);
	recentlyRespawned[PlayerNumber()] = false;
	int respawnProtectionTime = 35*DN_RESPAWNTIME; //4 segundos de proteccion al respawnear
	//Obtener posicion inicial del jugador, para modo Resurreccion
	int x = GetActorX(acTid);
	int y = GetActorY(acTid);
	int z = GetActorZ(acTid);
	//ACS_ExecuteAlways(670, 0, PlayerNumber());
	int tPassed = 980;
	int rPassed = 9; //casi 1/4 de segundo
	while(PlayerInGame(PlayerNumber())) {
		PactPos[PlayerNumber()][0] = GetActorX(acTid);
		PactPos[PlayerNumber()][1] = GetActorY(acTid);
		PactPos[PlayerNumber()][2] = GetActorZ(acTid);
		PlayerAngle[PlayerNumber()] = GetActorAngle(acTid);
		//HudMessageBold(s:"X: ", f:PactPos[PlayerNumber()][0], s:" - Y: ", f:PactPos[PlayerNumber()][1], s:" - Z: ", f:PactPos[PlayerNumber()][1]; HUDMSG_PLAIN, 5, CR_GOLD, 1.8, 0.8, 1);
		
		if (recentlyRespawned[PlayerNumber()])
		{
			if (respawnProtectionTime <= 0)
			{
				SetActorProperty(0, APROP_HEALTH, 100);
				fadeTo(115, 162, 255, 0.0, 0.5);
				respawnProtectionTime = 35*DN_RESPAWNTIME;
				recentlyRespawned[PlayerNumber()] = false;
			} else {
				if (GetActorProperty(0, APROP_HEALTH) < 200)
					SetActorProperty(0, APROP_HEALTH, 200);
			}
			respawnProtectionTime--;
		}
		
		tPassed--;
		if (tPassed <=0)
		{
			PactOldPos[PlayerNumber()][cActOldPos[PlayerNumber()]][0] = GetActorX(acTid);
			PactOldPos[PlayerNumber()][cActOldPos[PlayerNumber()]][1] = GetActorY(acTid);
			PactOldPos[PlayerNumber()][cActOldPos[PlayerNumber()]][2] = GetActorZ(acTid);

			cActOldPos[PlayerNumber()]++;
			if (cActOldPos[PlayerNumber()] >= MAXOLDPOS)
				cActOldPos[PlayerNumber()] = 0;
			tPassed = 980;
		}
		rPassed--;
		if (rPassed <= 0)
		{
			PrecentPos[PlayerNumber()][cRecentPos[PlayerNumber()]][0] = GetActorX(acTid);
			PrecentPos[PlayerNumber()][cRecentPos[PlayerNumber()]][1] = GetActorY(acTid);
			PrecentPos[PlayerNumber()][cRecentPos[PlayerNumber()]][2] = GetActorZ(acTid);

			cRecentPos[PlayerNumber()]++;
			if (cRecentPos[PlayerNumber()] >= MAXOLDPOS)
				cRecentPos[PlayerNumber()] = 0;
			
			rPassed = 9;
		}
		delay(1);
	}
}

script 667 DEATH
{
	delay(1);
	Palive[PlayerNumber()] = FALSE;
}

script 668 RESPAWN
{
	delay(1);
	Palive[PlayerNumber()] = TRUE;
	recentlyRespawned[PlayerNumber()] = true;
	fadeTo(115, 162, 255, 0.3, 0.5);
}

script 669 (int gone) DISCONNECT 
{
	Palive[gone] = FALSE;
}